import { useToggleScope } from "./toggleScope.mjs";
import { computed, onScopeDispose, reactive, readonly, ref, watchEffect } from 'vue';
import { getCurrentInstance } from "../util/index.mjs"; // Types

const stack = reactive([]);
export function useStack(isActive, zIndex) {
  const vm = getCurrentInstance('useStack');

  const _zIndex = ref(+zIndex.value);

  useToggleScope(isActive, () => {
    var _stack$at;

    const lastZIndex = (_stack$at = stack.at(-1)) == null ? void 0 : _stack$at[1];
    _zIndex.value = lastZIndex ? lastZIndex + 10 : +zIndex.value;
    stack.push([vm.uid, _zIndex.value]);
    onScopeDispose(() => {
      const idx = stack.findIndex(v => v[0] === vm.uid);
      stack.splice(idx, 1);
    });
  });
  const isTop = ref(true);
  watchEffect(() => {
    var _stack$at2;

    const _isTop = ((_stack$at2 = stack.at(-1)) == null ? void 0 : _stack$at2[0]) === vm.uid;

    setTimeout(() => isTop.value = _isTop);
  });
  return {
    isTop: readonly(isTop),
    stackStyles: computed(() => ({
      zIndex: _zIndex.value
    }))
  };
}
//# sourceMappingURL=stack.mjs.map